; diving sim by norc of CSP
Graphics3D 640,480,16,1
SeedRnd 777
Dim cosinus(640)
position = 0
For c = 0 To 640
 cosinus(c) = Cos((115*3.14159265358 * c) / 320) * 32 + 32
Next 

SetBuffer BackBuffer()

AmbientLight 90,90,100

; Camera
camera=CreateCamera()
CameraRange camera,0.1,17000
CameraFogMode camera,1
CameraFogRange camera,400,5500
CameraFogColor camera,150,170,200
CameraClsMode camera,1,1
CameraClsColor camera,150,170,200

light=CreateLight()
RotateEntity light,0,0,45
PositionEntity light,40,300,45

PositionEntity camera,Kx#,Ky#,Kz#
myangel#=110
RotateEntity camera,0,myangel,0

EntityType camera,TYPE_PLAYER
EntityRadius camera,3.4;3.4


; seafloor terrain
ground=LoadTerrain("seahmap1.bmp")
For i=0 To 127 
 For j=0 To 127
  tlo#=(TerrainHeight(ground,i,j)+Rnd(-0.1,0.1))/2
  If tlo#<0 Then tlo#=0
  If tlo#>0.62 Then tlo#=0.65
  ModifyTerrain ground,(i),(j),tlo#
 Next
Next
h059#=0.65
For i=0 To 128 
 ModifyTerrain ground,i,0,h059#
 ModifyTerrain ground,i,127,h059#
 ModifyTerrain ground,0,i,h059#
 ModifyTerrain ground,127,i,h059#
Next

TerrainShading ground,1  

ScaleEntity ground,500/4,1000,500/4
PositionEntity ground,-8000,0,-8000
TranslateEntity ground,0,-650,0

; Water-Terrain
mywater=CreateTexture(32,32,9)
mywater2=CreateTexture(32,32,9)
Gosub water

water=CreateTerrain(1)
; 2. waterlayer
waterb=CreateTerrain(1)
waterbtex=LoadTexture("water2.jpg")
ScaleTexture waterbtex,0.2,0.2
EntityTexture waterb,waterbtex
ScaleEntity waterb,500*32,500*32,500*32
PositionEntity waterb,-8000,0,-8000
EntityAlpha waterb,0.3
EntityFX waterb,17
ScaleTexture mywater,0.01,0.01
ScaleTexture mywater2,2,2
EntityTexture water, mywater,0
ScaleEntity water,500*32,500*32,500*32
PositionEntity water,-8000,0,-8000
EntityAlpha water,0.6
EntityFX water,17

sky=CreateSphere()
FlipMesh sky
sky_tex=LoadTexture("sky.bmp")
moss_tex=LoadTexture("mossyground.bmp")
EntityTexture sky,sky_tex
ScaleTexture sky_tex,0.2,0.2
ScaleTexture moss_tex,5,5
ScaleEntity sky,6000,12000,6000
EntityFX sky,9
EntityOrder sky,1

ScaleTexture moss_tex,0.025,0.5 
PositionEntity sky,Kx#,Ky#,Kz#

trueb=CreateCube()
FlipMesh trueb
ScaleEntity trueb,10,10,10
EntityTexture trueb,mywater2 
EntityAlpha trueb,0.6 
EntityFX trueb,1

groundtex=LoadTexture("rockground.jpg")
ScaleTexture groundtex,10,10
TextureBlend groundtex,3
EntityTexture ground,groundtex,0,0
EntityTexture ground,mywater2,0,1


fish=LoadSprite("fish2.bmp",13)
EntityFX fish,16
SpriteViewMode fish,2
ScaleSprite fish,30,30

fish2=LoadSprite("fishfro2.bmp",13,fish)
RotateEntity fish2,0,90,0
EntityFX fish2,16
SpriteViewMode fish2,2
ScaleSprite fish2,7.5,30
TranslateEntity fish2,-3,0,0

nofishesi=10
nofishesj=3
nofishesk=10
nofishesj10=nofishesj*80

Dim fishes(nofishesi,nofishesj,nofishesk) ; fishes handles verti-sprite
Dim fishes2(nofishesi,nofishesj,nofishesk) ; fishes handles hori-sprite
Dim fishes_x#(nofishesi,nofishesj,nofishesk) ; fishes offset to leader
Dim fishes_y#(nofishesi,nofishesj,nofishesk)
Dim fishes_z#(nofishesi,nofishesj,nofishesk)

Dim fishes_xp#(nofishesi) ; swarm step
Dim fishes_zp#(nofishesi)
Dim fishes_a#(nofishesi)

Dim fishes_xg#(nofishesi) ; swarm leader
Dim fishes_zg#(nofishesi)


For k=0 To nofishesk
For j=0 To nofishesj
For i=0 To nofishesi
fishes(i,j,k)=CopyEntity(fish)

fishes_x(i,j,k)=(i*100)+Rand(400)
fishes_y(i,j,k)=(j*40)+Rand(35)
fishes_z(i,j,k)=(k*100)+Rand(400)
Next
Next
Next

For k=0 To nofishesk
For j=0 To nofishesj
For i=0 To nofishesi
yloc#=(TerrainY(ground,fishes_x(i,j,k),0,fishes_z(i,j,k))/nofishesj10)*fishes_y(i,j,k)
PositionEntity fishes(i,j,k),fishes_x(i,j,k),yloc#,fishes_z(i,j,k)
Next
Next
Next

FreeEntity fish
.nixfish
fishxp#=1
fishzp#=2

For i=0 To nofishesi
fishes_xp#(i)=1
fishes_zp#(i)=2
fishes_a#(i)=ATan2((fishes_xp#(i)*180)+180,(fishes_zp#(i)*180)+180)
Next


fisha#=ATan2((fishxp#*180)+180,(fishzp#*180)+180)
For k=0 To nofishesk
For j=0 To nofishesj
For i=0 To nofishesi
RotateEntity fishes(i,j,k),0,fisha#,0
Next
Next
Next

; some ruins
mayatex2=LoadTexture("maya5.jpg",9) 

Dim ruinwall(10)
Dim ruinsoil(10)
For i=0 To 5
ruinwall(i)=LoadMesh("dddutch1.3ds")
ScaleEntity ruinwall(i),20,20,20
If Rand(100)>49
 If Rand(100)>49
  rux#=Rnd(-7000,7000)
  ruz#=Rnd(-7000,7000)
 Else
  rux#=Rnd(2000,7000)
  ruz#=Rnd(-7000,7000)
 EndIf
Else
 If Rand(100)>49
  rux#=Rnd(-7000,7000)
  ruz#=Rnd(-7000,-2000)
 Else
  rux#=Rnd(-7000,7000)
  ruz#=Rnd(2000,7000)
 EndIf
EndIf
  rux#=Rnd(-7000,7000)
  ruz#=Rnd(-7000,7000)
PositionEntity ruinwall(i),rux#,TerrainY(ground,rux#,0,ruz#)+1100,ruz#
RotateEntity ruinwall(i),Rnd(-20,20),Rnd(0.0,330.0),Rnd(-20,20)

ruinsoil(i)=CreateCube()
ScaleEntity ruinsoil(i),100,600,100
If Rand(100)>49
 If Rand(100)>49
  rux#=Rnd(-7000,-2000)
  ruz#=Rnd(-7000,7000)
 Else
  rux#=Rnd(2000,7000)
  ruz#=Rnd(-7000,7000)
 EndIf
Else
 If Rand(100)>49
  rux#=Rnd(-7000,7000)
  ruz#=Rnd(-7000,-2000)
 Else
  rux#=Rnd(-7000,7000)
  ruz#=Rnd(2000,7000)
 EndIf
EndIf
PositionEntity ruinsoil(i),rux#,TerrainY(ground,rux#,0,ruz#)-75,ruz#
RotateEntity ruinsoil(i),Rnd(-20,20),Rnd(360),90+Rnd(-10,10)
EntityTexture ruinsoil(i),mayatex2

Next

tt=MilliSecs()
tt2=tt-50
HidePointer
; ______________________________________MAINLOOP_____________________________________
While KeyDown(1)=0
 my=MouseYSpeed()*5
PositionTexture waterbtex,0,watb#
watb#=watb#+0.001
If watb#>0.999 Then
 watb#=0.0
EndIf

 Gosub water
For i=0 To nofishesi
 If KeyDown(57)=0
 fishes_xg#(i)=fishes_xg#(i)+fishes_xp#(i)*6
 fishes_zg#(i)=fishes_zg#(i)+fishes_zp#(i)*6
 EndIf
 drehn=0
 If fishes_xg#(i)>4000 Or Rand(1000)>998
  fishes_xp#(i)=-(1+Rnd(1.0))
  drehn=1
  fishes_a#(i)=ATan2((fishes_zp#(i)*180),(fishes_xp#(i)*180))
 EndIf
 If fishes_xg#(i)<-8000 Or Rand(1000)>998
  fishes_xp#(i)=(1+Rnd(1.0))
  drehn=1
  fishes_a#(i)=ATan2((fishes_zp#(i)*180),(fishes_xp#(i)*180))
 EndIf
 If fishes_zg#(i)>0 Or Rand(1000)>998
  fishes_zp#(i)=-(1+Rnd(1.0))
  drehn=1
  fishes_a#(i)=ATan2((fishes_zp#(i)*180),(fishes_xp#(i)*180))
 EndIf
 If fishes_zg#(i)<-8000 Or Rand(1000)>998
  fishes_zp#(i)=(1+Rnd(1.0))
  drehn=1
  fishes_a#(i)=ATan2((fishes_zp#(i)*180),(fishes_xp#(i)*180))
 EndIf

If drehn<>0
For k=0 To nofishesk
For j=0 To nofishesj
;For i=0 To nofishesi
RotateEntity fishes(i,j,k),0,fishes_a#(i)+Rnd(2.0),0
;Next
Next
Next
EndIf
Next

For k=0 To nofishesk
For j=0 To nofishesj
For i=0 To nofishesi
yloc#=(TerrainY(ground,fishes_xg#(i)+fishes_x(i,j,k),0,fishes_zg#(i)+fishes_z(i,j,k))/nofishesj10)*fishes_y(i,j,k)-20
PositionEntity fishes(i,j,k),fishes_xg#(i)+fishes_x(i,j,k),yloc#,fishes_zg#(i)+fishes_z(i,j,k)
Next
Next
Next



 If KeyDown(200)=1 ; forward
  If speed#<50
   speed#=speed#+2
  EndIf 
 EndIf
 If speed#>0 
  speed#=speed#-1
  If speed#<0 
   speed#=0
  EndIf
 EndIf
 If KeyDown(208)=1 ; backward
  If speed#>-50
   speed#=speed#-2
  EndIf 
 EndIf
 If speed#<0 
  speed#=speed#+1
  If speed#>0 
   speed#=0
  EndIf
 EndIf

 Kx#=kx#-Cos(myangel#-90)*speed#
 Kz#=kz#-Sin(myangel#-90)*speed#

 camy2#=camy2#-my
 If camy2#>570 Then camy2#=570
 If camy2#<-500 Then camy2#=-500

 If camy#<>camy2#
  camy#=camy#+((camy2#-camy#)/5)
 EndIf

 terry#=TerrainY(ground,kx#,0,kz#)+20
 If camy#<terry# Then camy#=terry# 
 PositionEntity camera,Kx#,camy#,Kz#
 moro#=MouseXSpeed()
 myangel2#=myangel2#-moro#
 If myangel2#<>myangel#
  myangel#=myangel#+((myangel2#-myangel#)/5)
  roll2#=myangel2#-myangel# 
  If roll2#<>roll#
   roll#=roll#+((roll2#-roll#)/5)
  EndIf
 EndIf
 RotateEntity camera,0,myangel#,roll#
 trueby#=camy#
 If trueby#>-10 Then trueby#=-10
 PositionEntity trueb,Kx#,trueby#,Kz#
 RotateEntity trueb,0,myangel#,roll#
PositionEntity sky,Kx#,0,Kz#
 MoveMouse 320,240
 UpdateWorld()
 RenderWorld()

; fps counter
tt=MilliSecs()
fps=1000.0/(tt-tt2)
tt2=tt
;Text 0,0,fps
;Text 0,10,kx
;Text 0,20,kz
 Flip

Wend

End

.water
 wave1% = wave1% + 8
 If wave1% >= 320 Then wave1% = 0 
 wave2% = wave2% + 4
 If wave2% >= 320 Then wave2% = 0
 SetBuffer TextureBuffer(mywater)
 LockBuffer
   For y% = 0 To 319 Step 10
    y10=y%/10
    d = cosinus(y + wave2) + cosinus(Y + wave2)
    For x = 0 To 319 Step 10
     x10=x/10
     f = 1 + Abs(((cosinus(x + wave1) + cosinus(x + y) + d) / 8) - 16)
     rr=105-(f*3)
If rr<0 Then rr=0
     gg=185-(f*4.5)
If gg<0 Then gg=0
     bb=195-(f*5)
If bb<0 Then bb=0
    WritePixelFast x10,y10,((rr Shl 16) Or (gg Shl 8) Or bb)
   Next 
  Next
 UnlockBuffer
CopyRect 0,0,32,32,0,0, TextureBuffer(mywater), TextureBuffer(mywater2)
SetBuffer BackBuffer()
Return
